import greenfoot.*; // (World, Actor, GreenfootImage, and Greenfoot)
/**
*A sperclass for spacifiec avtor class that add smoothmover movement functionallity.
*
*
*Movement is based on doubles (rather that ints), and thus generates smoother
*movement for the fast moving acters in high resolution worlds.
*
*The smoothMover also implements world wrap-arounds when moving out of the world at any edge,
*the actor will enter again at the opposite side.
*
*Requires class vector.
*
*@auther poul Henrikeen
*
*/

public abstract class SmoothMover extends Actor
{
private Vector speed = new Vector();
private double x = 0;
private double y = 0;

public SmoothMover()
{
}

/**
*creates mew thing intialised with given speed.
*/
public SmoothMover(Vector speed)
{
this.speed = speed;
}
/**
*Move forward one step
*/

public void move()
{
x =x + speed.getX();
y =y + speed.getY();
if (outOffWorld())
{
getWorld().removeObject(this);
}
else {
setLocation(x, y);
}
}

private boolean outOffWorld()
{

return (x >= getWorld().getWidth()) 
|| (x < 0) 
|| (y >= getWorld().getHeight()) 
|| (y < 0); //could be -
}

/** Providing setLocation based on doubles. this will eventually call
*the build in setLoction method in actor
*/

public void setLocation(double x, double y)
{
this.x = x;
this.y = y;
super.setLocation((int) x, (int) y);
}

/** 
*Overrides the default 'setLocation' method to keep our own coordinates
*up-to-date.
*/

public void setLocation(int x, int y)
{
setLocation((double) x, (double) y);
}
/**
*Increases the speed waith the given vector.
*
*/
public void increaseSpeed(Vector s)
{
speed.add(s);
}
/**
*Returns the current speed
*
*/
public Vector getSpeed()
{
return speed;
}
}